package com.oqpo.api.service.oper;


import com.oqpo.api.entity.oper.MainChartEntity;
import com.oqpo.api.mapper.oper.MainChartMapper;
import com.oqpo.api.service.CommonService;
import com.oqpo.api.web.dto.response.oper.mainchart.ChartResponse;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.parameters.P;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
@Slf4j
public class MainChartService extends CommonService {

    @Autowired
    private MainChartMapper mainChartMapper;

    public ChartResponse selectPchReqChart(String brandId, String storeId, String prType) throws Exception {
        MainChartEntity entity = mainChartMapper.selectPchReqChart(brandId, storeId, prType);

        String chartData = "[ [' ', '대기', '반려', '승인'], [' ', " + entity.getPr20Val() + " , " + entity.getPr30Val() + " , " + entity.getPr40Val() + "] ]";

        ChartResponse result = new ChartResponse();
        result.setChartData(chartData);
        return result;
    }

    public ChartResponse selectPchOdrChart(String brandId, String storeId, String poType) throws Exception {
        MainChartEntity entity = mainChartMapper.selectPchOdrChart(brandId, storeId, poType);

        String chartData = "[ [' ', '요청', '진행', '취소'], [' ', " + entity.getPo20Val() + " , " + entity.getPo30Val() + " , " + entity.getPo99Val() + "] ]";

        ChartResponse result = new ChartResponse();
        result.setChartData(chartData);
        return result;
    }

    public ChartResponse selectPrRankChart(String brandId, String storeId, String prType) throws Exception {
        List<MainChartEntity> entityList = mainChartMapper.selectPrRankChart(brandId, storeId, prType);

        StringBuffer retVal = new StringBuffer();
        if (entityList == null || entityList.size() < 1) {
            retVal.append("[ [' ', '상품없음'], [' ', 0] ]");
        } else {
            retVal.append("[  [' '");
            for (MainChartEntity entity : entityList) {
                retVal.append(", '" + entity.getItemNm() + "'");
            }
            retVal.append("], [' '");
            for (MainChartEntity entity : entityList) {
                retVal.append(", " + entity.getItemCnt());
            }
            retVal.append("]  ]");
        }
        ChartResponse result = new ChartResponse();
        result.setChartData(retVal.toString());
        return result;
    }

    public ChartResponse selectStlChart(String brandId, String storeId) throws Exception {
        MainChartEntity entity = mainChartMapper.selectStlChart(brandId, storeId);

        // String chartData = "[ [' ', '요청', '확인', '반려'], [' ', " + entity.getSt10Val() + " , " + entity.getSt20Val() + " , " + entity.getSt30Val() + "] ]";
        String chartData = "[ [' ', ' '], ['요청', " + entity.getSt10Val() + "], ['확인', " + entity.getSt20Val() + "], ['반려', " + entity.getSt30Val() + "] ]";

        ChartResponse result = new ChartResponse();
        result.setChartData(chartData);
        return result;
    }

    public ChartResponse selectSftStckChart(String brandId, String storeId) throws Exception {
        List<MainChartEntity> entityList = mainChartMapper.selectSftStckChart(brandId, storeId);

        // String chartData = "[ [' ', '안전재고수량', '현재재고수량'], ['품목1', 1000, 400], ['품목2', 1170, 460], ]";
        StringBuffer charVal = new StringBuffer();
        for (MainChartEntity entity : entityList) {
            charVal.append("['" + entity.getItemNm() + "', " + entity.getSftStckQty() + ", " + entity.getStckQty() + "], ");
        }
        ChartResponse result = new ChartResponse();
        result.setChartData("[ [' ', '안전재고수량', '현재재고수량'], " + charVal.toString() + " ]");
        return result;
    }

}
