package com.oqpo.api.web.dto.response.oper.usermng;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.oqpo.api.entity.oper.UserMngEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.*;

@Getter
@Setter
@Builder
@AllArgsConstructor(access = AccessLevel.PROTECTED)
@JsonInclude(JsonInclude.Include.ALWAYS)
public class UserInfoResponse {

    @ApiModelProperty(value = "브랜드그룹아이디")
    private String afflShopId;

    @ApiModelProperty(value = "브랜드그룹명")
    private String afflShopNm;

    @ApiModelProperty(value = "브랜드아이디")
    private String brandId;

    @ApiModelProperty(value = "브랜드명")
    private String brandNm;

    @ApiModelProperty(value = "사용자ID")
    private String userId;

    @ApiModelProperty(value = "사용자명")
    private String userNm;

    @ApiModelProperty(value = "전화번호")
    private String telNo;

    @ApiModelProperty(value = "이메일")
    private String email;

    @ApiModelProperty(value = "상태코드")
    private String userStatCd;

    @ApiModelProperty(value = "상태코드명")
    private String userStatNm;

    @ApiModelProperty(value = "상태일시")
    private String userStatDt;

    @ApiModelProperty(value = "가입일")
    private String addDt;

    @ApiModelProperty(value = "마지막로그인일자")
    private String lastLoginDt;

    public static UserInfoResponse toDTO(UserMngEntity entity) {
        if (entity == null) return null;
        return UserInfoResponse.builder()
                .afflShopId(entity.getAfflShopId() == null ? "" : entity.getAfflShopId())
                .afflShopNm(entity.getAfflShopNm() == null ? "" : entity.getAfflShopNm())
                .brandId(entity.getBrandId() == null ? "" : entity.getBrandId())
                .brandNm(entity.getBrandNm() == null ? "" : entity.getBrandNm())
                .userId(entity.getUserId())
                .userNm(entity.getUserNm())
                .telNo(entity.getTelNo())
                .email(entity.getEmail())
                .userStatCd(entity.getUserStatCd())
                .userStatNm(entity.getUserStatNm())
                .userStatDt(entity.getUserStatDt())
                .addDt(entity.getAddDt())
                .lastLoginDt(entity.getLastLoginDt() == null ? "" : entity.getLastLoginDt())
                .build();
    }
}
